#!/usr/bin/env perl

use Data::Dumper;
use POSIX qw/strftime locale_h/;
use HTML::Template;
require "/usr/share/libcgi-yazzy/cgi.pl";

setlocale(LC_TIME, 'C');
$ENV{'TZ'} = "GMT";


sub uniq
{
	my @uniq;
	for(@_){ push @uniq, $_ unless $_ ~~ @uniq; }
	return @uniq;
}

sub intersect
{
	my @sets = @_;
	return undef if scalar @sets < 1;
	my @intersect = @{$sets[0]};
	for my $set (@sets[1..$#sets])
	{
		my @new_intersect;
		for my $elm (@intersect)
		{
			if($elm ~~ @$set)
			{
				push @new_intersect, $elm;
			}
		}
		@intersect = @new_intersect;
		last if not @intersect;
	}
	return @intersect;
}


# Begin Main

	$scheme = $ENV{'REQUEST_SCHEME'};
	($blockers, $latest_token, $latest_token_user) = split /\s+/, $_GET{'blockers'};
	# split $blockers at semicolons: split /;/
	# eliminate duplicated chunks: uniq
	# split these chunks at commas: split /,/
	@blockers = map {[split /,/]} uniq split /;/, $blockers;
	# find words which are common in all sets
	@common = intersect @blockers;
	$disable_inputs = 0;
	if($blockers)
	{
		$disable_inputs = 1;
		for my $lst (@blockers)
		{
			if(not "cidr" ~~ @$lst and (not "scheme" ~~ @$lst or $scheme =~ /s$/))
			{
				$disable_inputs = 0;
				last;
			}
		}
	}
	
	$tmpl = HTML::Template->new(filename => '/usr/share/authd-htpasswd/login.htm', die_on_bad_params => 0, loop_context_vars => 1, global_vars => 1);
	$tmpl->param('scheme', $scheme);
	$tmpl->param('host', $ENV{'HOST'} || $ENV{'HTTP_HOST'});
	$tmpl->param('remote_addr', $ENV{'REMOTE_ADDR'});
	$tmpl->param('request_method', $ENV{'HTTP_ORIGINAL_REQUEST_METHOD'} || $_GET{'request-method'});
	$tmpl->param('request_uri', $ENV{'REQUEST_URI'});
	$tmpl->param('path', $_GET{'path'});
	$tmpl->param('extra_paths', $_GET{'extra-paths'});
	$tmpl->param('blockers', $blockers);
	$tmpl->param('blocker-list', [map {{"inner-list"=>[map {{"b-$_"=>1}} @$_], "factors"=>join',',@$_}} @blockers]);
	$tmpl->param('bad-user', $latest_token_user);
	$tmpl->param('is-anon', $latest_token_user ? $latest_token eq "Anon" : 1);
	$tmpl->param('disable-inputs', $disable_inputs);
	
	
	$\ = $CRLF;
	print "Status: 200 OK";
	print "Content-Type: text/html";
	print "Cache-Control: no-cache";
	print "Expires: Thu, 01-Jan-1970 00:00:00 GMT";
	print "";
	print $tmpl->output;
